--
--    Addon by Dutchmagé 
--    LUpdate: 21-03-2016
--

MagePortalWhispers = LibStub("AceAddon-3.0"):NewAddon("MagePortalWhispers", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0", "AceComm-3.0", "AceSerializer-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("MagePortalWhispers", true)
local LibC = LibStub:GetLibrary("LibCompress")
local LibCE = LibC:GetAddonEncodeTable()
local debug = false
local playername = ''
local default_whisper = "Sorry i don't give portals right now"
local player_class = UnitClass("player")

function isMage()
    return player_class:lower():match('mage')
end

local badwords =
{
  "ahole",
  "anus",
  "ash0le",
  "ash0les",
  "asholes",
  "ass",
  "Ass",
  "Assface",
  "assh0le",
  "assh0lez",
  "asshole",
  "assholes",
  "assholz",
  "asswipe",
  "azzhole",
  "bassterds",
  "bastard",
  "bastards",
  "bastardz",
  "basterds",
  "basterdz",
  "Biatch",
  "bitch",
  "bitches",
  "Blow",
  "boffing",
  "butthole",
  "buttwipe",
  "c0ck",
  "c0cks",
  "c0k",
  "Carpet",
  "cawk",
  "cawks",
  "Clit",
  "cnts",
  "cntz",
  "cock",
  "cockhead",
  "cock-head",
  "cocks",
  "CockSucker",
  "cock-sucker",
  "crap",
  "cum",
  "cunt",
  "cunts",
  "cuntz",
  "douch",
  "douchbag",
  "dick",
  "dild0",
  "dild0s",
  "dildo",
  "dildos",
  "dilld0",
  "dilld0s",
  "dominatricks",
  "dominatrics",
  "dominatrix",
  "dyke",
  "enema",
  "f",
  "fag",
  "fag1t",
  "faget",
  "fagg1t",
  "faggit",
  "faggot",
  "fagit",
  "fags",
  "fagz",
  "faig",
  "faigs",
  "fart",
  "flipping",
  "fuck",
  "fucker",
  "fuckin",
  "fucking",
  "fucks",
  "Fudge",
  "fuk",
  "Fukah",
  "Fuken",
  "fuker",
  "Fukin",
  "Fukk",
  "Fukkah",
  "Fukken",
  "Fukker",
  "Fukkin",
  "g00k",
  "gay",
  "gayboy",
  "gaygirl",
  "gays",
  "gayz",
  "God-damned",
  "h00r",
  "h0ar",
  "h0re",
  "hells",
  "hoar",
  "hoor",
  "hoore",
  "jackoff",
  "jap",
  "japs",
  "jerk-off",
  "jisim",
  "jiss",
  "jizm",
  "jizz",
  "knob",
  "knobs",
  "knobz",
  "kunt",
  "kunts",
  "kuntz",
  "Lesbian",
  "Lezzian",
  "Lipshits",
  "Lipshitz",
  "masochist",
  "masokist",
  "massterbait",
  "masstrbait",
  "masstrbate",
  "masterbaiter",
  "masterbate",
  "masterbates",
  "Motha",
  "Mother",
  "mother-fucker",
  "Mutha",
  "n1gr",
  "nastt",
  "nigger;",
  "nigur;",
  "niiger;",
  "niigr;",
  "orafis",
  "orgasim;",
  "orgasm",
  "orgasum",
  "oriface",
  "orifice",
  "orifiss",
  "packi",
  "packie",
  "packy",
  "paki",
  "pakie",
  "paky",
  "pecker",
  "peeenus",
  "peeenusss",
  "peenus",
  "peinus",
  "pen1s",
  "penas",
  "penis",
  "penis-breath",
  "penus",
  "penuus",
  "Phuc",
  "Phuck",
  "Phuk",
  "Phuker",
  "Phukker",
  "polac",
  "polack",
  "polak",
  "Poonani",
  "pr1c",
  "pr1ck",
  "pr1k",
  "pusse",
  "pussee",
  "pussy",
  "puuke",
  "puuker",
  "queer",
  "queers",
  "queerz",
  "qweers",
  "qweerz",
  "qweir",
  "recktum",
  "rectum",
  "retard",
  "sadist",
  "scank",
  "schlong",
  "screwing",
  "semen",
  "sex",
  "sexy",
  "Sh!t",
  "sh1t",
  "sh1ter",
  "sh1ts",
  "sh1tter",
  "sh1tz",
  "shit",
  "shits",
  "shitter",
  "Shitty",
  "Shity",
  "shitz",
  "Shyt",
  "Shyte",
  "Shytty",
  "Shyty",
  "skanck",
  "skank",
  "skankee",
  "skankey",
  "skanks",
  "Skanky",
  "slut",
  "sluts",
  "Slutty",
  "slutz",
  "son-of-a-bitch",
  "tit",
  "turd",
  "va1jina",
  "vag1na",
  "vagiina",
  "vagina",
  "vaj1na",
  "vajina",
  "vullva",
  "vulva",
  "w0p",
  "wh00r",
  "wh0re",
  "whore",
  "xrated",
  "xxx",
  "b!+ch",
  "blowjob",
  "clit",
  "arschloch",
  "b!tch",
  "b17ch",
  "b1tch",
  "bi+ch",
  "boiolas",
  "buceta",
  "chink",
  "cipa",
  "clits",
  "dirsa",
  "ejakulate",
  "fatass",
  "fcuk",
  "fux0r",
  "hoer",
  "hore",
  "jism",
  "kawk",
  "l3itch",
  "l3i+ch",
  "lesbian",
  "masturbate",
  "masterbat*",
  "masterbat3",
  "motherfucker",
  "s.o.b.",
  "mofo",
  "nazi",
  "nigga",
  "nigger",
  "nutsack",
  "phuck",
  "pimpis",
  "scrotum",
  "sh!t",
  "shemale",
  "shi+",
  "sh!+",
  "smut",
  "teets",
  "tits",
  "boobs",
  "b00bs",
  "teez",
  "testical",
  "testicle",
  "titt",
  "w00se",
  "wank",
  "whoar",
  "*damn",
  "*dyke",
  "*fuck*",
  "*shit*",
  "@$$",
  "amcik",
  "andskota",
  "arse*",
  "assrammer",
  "ayir",
  "bi7ch",
  "bitch*",
  "bollock*",
  "breasts",
  "butt-pirate",
  "cabron",
  "cazzo",
  "chraa",
  "chuj",
  "Cock*",
  "cunt*",
  "d4mn",
  "daygo",
  "dego",
  "dick*",
  "dike*",
  "dupa",
  "dziwka",
  "ejackulate",
  "Ekrem*",
  "Ekto",
  "enculer",
  "faen",
  "fag*",
  "fanculo",
  "fanny",
  "feces",
  "feg",
  "Felcher",
  "ficken",
  "fitt*",
  "Flikker",
  "foreskin",
  "Fotze",
  "Fu(*",
  "fuk*",
  "futkretzn",
  "gook",
  "guiena",
  "h0r",
  "h4x0r",
  "hell",
  "helvete",
  "hoer*",
  "honkey",
  "Huevon",
  "hui",
  "injun",
  "kanker*",
  "kike",
  "klootzak",
  "kraut",
  "knulle",
  "kuk",
  "kuksuger",
  "Kurac",
  "kurwa",
  "kusi*",
  "kyrpa*",
  "lesbo",
  "mamhoon",
  "masturbat*",
  "merd*",
  "mibun",
  "monkleigh",
  "mouliewop",
  "muie",
  "mulkku",
  "muschi",
  "nazis",
  "nepesaurio",
  "nigger*",
  "orospu",
  "paska*",
  "perse",
  "picka",
  "pierdol*",
  "pillu*",
  "pimmel",
  "piss*",
  "pizda",
  "poontsee",
  "poop",
  "porn",
  "p0rn",
  "pr0n",
  "preteen",
  "pula",
  "pule",
  "puta",
  "puto",
  "qahbeh",
  "queef*",
  "rautenberg",
  "schaffer",
  "scheiss*",
  "schlampe",
  "schmuck",
  "screw",
  "sh!t*",
  "sharmuta",
  "sharmute",
  "shipal",
  "shiz",
  "skribz",
  "skurwysyn",
  "sphencter",
  "spic",
  "spierdalaj",
  "splooge",
  "suka",
  "b00b*",
  "testicle*",
  "titt*",
  "twat",
  "vittu",
  "wank*",
  "wetback*",
  "wichser",
  "wop*",
  "yed",
  "zabourah"
}

-- get option value
local function GetGlobalOptionLocal(info)
	return MagePortalWhispers.db.global[info[#info]]
end

-- set option value
local function SetGlobalOptionLocal(info, value)
	if debug and MagePortalWhispers.db.global[info[#info]] ~= value then
		MagePortalWhispers:Printf("DEBUG: global option %s changed from '%s' to '%s'", info[#info], tostring(GuildRecr.db.global[info[#info]]), tostring(value))
	end
	MagePortalWhispers.db.global[info[#info]] = value
	LibStub("AceConfigRegistry-3.0"):NotifyChange("MagePortalWhispers")
end

-- declare defaults to be used in the DB
local defaults = {
	realm = {
		enabled = isMage(),
		ignore = false,
		whisper = default_whisper,
        enable_afk = false,
        display_whisper_overlay = false
	},
	global = {
		enabled = isMage(),
		ignore = false,
		whisper = default_whisper,
        enable_afk = false,
        display_whisper_overlay = false
	}
}

-- a filter to hide all yelled messaged containing certain text
function NoWhisperWindow(self,event,msg)

  return (msg:lower():match('portal') or 
        msg:lower():match('portals') or 
        msg:lower():match('teleport') or 
        msg:lower():match('teleports'))
  
end

function InitTextFrame()
    MOD_TextFrame = CreateFrame("Frame");
    MOD_TextFrame:ClearAllPoints();
    MOD_TextFrame:SetHeight(300);
    MOD_TextFrame:SetWidth(300);
    MOD_TextFrame:SetScript("OnUpdate", MOD_TextFrame_OnUpdate);
    MOD_TextFrame:Hide();
    MOD_TextFrame.text = MOD_TextFrame:CreateFontString(nil, "BACKGROUND", "PVPInfoTextFont");
    MOD_TextFrame.text:SetAllPoints();
    MOD_TextFrame:SetPoint("CENTER", 0, 200);
    MOD_TextFrameTime = 0;
end

function MOD_TextFrame_OnUpdate()
  if (MOD_TextFrameTime < GetTime() - 3) then
    local alpha = MOD_TextFrame:GetAlpha();
    if (alpha ~= 0) then MOD_TextFrame:SetAlpha(alpha - .05); end
    if (alpha == 0) then MOD_TextFrame:Hide(); end
  end
end

function MOD_TextMessage(message)
      MOD_TextFrame.text:SetText(message);
      MOD_TextFrame:SetAlpha(1);
      MOD_TextFrame:Show();
      MOD_TextFrameTime = GetTime();
end


-- Option menu (Interface-->Settings)
local options = {
    name = "Mage Portal Whisper - by Dutchmagé",
	type = "group",
	childGroups = "tab",
	args = {
		general_tab = {
			name = "General",
			type = "group",
			order = 10,
			args = {
				enabled = {
					type = "toggle",
					order = 2,
					name = "Enable Addon",
					desc = "Enable or disable addon functionality.",
					width = "full",
					get =	GetGlobalOptionLocal,
					set =	function (info, value)
								SetGlobalOptionLocal(info, value)
							end
				},
				ignore = {
					type = "toggle",
					order = 2,
					name = "Enable Ignore when swearing",
					desc = "Enable or disable Ignore when swearing functionality.",
					width = "full",
					get =	GetGlobalOptionLocal,
					set =	function (info, value)
								SetGlobalOptionLocal(info, value)
							end
				},
                display_whisper_overlay = 
                {
                   type = "toggle",
					order = 3,
					name = "Enable whisper from player in overlay",
					desc = "Enable or disable whisper in overlay.",
					width = "full",
					get =	GetGlobalOptionLocal,
					set =	function (info, value)
								SetGlobalOptionLocal(info, value)
							end   
                },
				whisper = 
				{
					type = "input",
					order = 4,
					name = "Whisper",
					multiline = true,
					desc = "Custom whisper message",
					width = "full",
					get = GetGlobalOptionLocal,
					set = function (info, value)
							  SetGlobalOptionLocal(info, value)
						  end
				}
			}
		}
	}	
}

-- get server time in unix timestamp format
local function GetServerTime()
	local weekday, month, day, year = CalendarGetDate()
	local hours, minutes = GetGameTime()
	
	local timeset = { year = year, month = month, day = day, hour = hours, min = minutes }
	
	return time(timeset)
end

local function isempty(s)
  return s == nil or s == ''
end

function MagePortalWhispers:WhisperBack()
	
	local dist, target
	dist, target = "WHISPER", dest
	
	playername = GetUnitName("player", true)
	f = CreateFrame("frame")
        
     f:RegisterEvent("CHAT_MSG_WHISPER")
    
        f:SetScript("OnEvent", function(self, event, msg, sender)
        
		if MagePortalWhispers.db.global.enabled then
            
            if not isempty(MagePortalWhispers.db.global.whisper) then
                wmessage = MagePortalWhispers.db.global.whisper
            end
			
            if msg:lower():match('portal') 
                or msg:lower():match('portals')
                or msg:lower():match('teleport') 
                or msg:lower():match('teleports') 
            then

                if not isempty(wmessage) then

                    if not debug then

                        -- if the player NOT matches yourself then..
                        if not sender:match(playername) then
                            if MagePortalWhispers.db.global.display_whisper_overlay then
                                InitTextFrame()
                                MOD_TextFrame:Hide();
                                MOD_TextMessage("|cffffff00"..sender.."|r: "..msg)
                            end
                            SendChatMessage(wmessage, "WHISPER", nil, sender);
                        else
                            MagePortalWhispers:Printf("Why are you whispering youself for portals? hic....")
                        end

                    else
                        -- if the player matches yourself then (DEBUGMODE)..
                        if sender:match(playername) then
                            if MagePortalWhispers.db.global.display_whisper_overlay then
                                -- Get the whisper of the player in an overlay and dissapear in 3 seconds.
                                MOD_TextMessage(msg)
                            end
                            -- Send a whisper to the player
                            SendChatMessage(string.gsub(wmessage, "portal", ""), "WHISPER", nil, sender);
                        end
                    end

                    else
                        MagePortalWhispers:Printf('Please define a Whisper text in /mpw or interface --> Mage Portal Whisper')
                    end

            end
		
          if MagePortalWhispers.db.global.ignore then
								
				for i=1,table.getn(badwords) do 	
					
					if msg:lower():match(badwords[i]) then
						
						if not sender:match(playername) then
					
                            --Adds the player to the ignore list...
							AddOrDelIgnore(playername)
						
							if not debug then
								MagePortalWhispers:Printf(playername..' is now on your ignore list')
							end
							
						else
							MagePortalWhispers:Printf("You can't ignore yourself")
						end
						
						do return end
					
					end
		
			end
		
		end
			
		do return end			
			
		end
			
	end)
	
end

-- Called when the addon is disabled
function MagePortalWhispers:OnDisable()
	
	-- unregister events
	self:UnregisterAllEvents()
	
	-- unregister comm events
	self:UnregisterAllComm()
	
	self:UnregisterChatCommand("mpb")
	
end

-- Called when the addon is enabled
function MagePortalWhispers:OnEnable()
    
    if isMage() then
        MagePortalWhispers:WhisperBack()
    else
        MagePortalWhispers:Printf("this addon can only be used on a Mage character")
    end
    
end

-- Process the slash command ("input" contains whatever follows the slash command)
function MagePortalWhispers:ConsoleCommand(input)
	-- show configuration window if no params given
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.configFrame)
	end
	
	if input == "debug" then
		self:Print("DEBUG: enabled")
		debug = true
	end

	if input == "nodebug" then
		self:Print("DEBUG: disabled")
		debug = false
	end
    
end


-- Code that you want to run when the addon is first loaded goes here.
function MagePortalWhispers:OnInitialize()

    if isMage() then
        
        -- initialize saved variables
        self.db = LibStub("AceDB-3.0"):New("MagePortalWhispersDB", defaults, true)

        -- initialize configuration options
        LibStub("AceConfig-3.0"):RegisterOptionsTable("MagePortalWhispersDB", options)
        self.configFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("MagePortalWhispersDB", "Mage Portal Whisper");

        -- create LibDataBroker
        self.ldb = LibStub("LibDataBroker-1.1"):NewDataObject("Mage Portal Whisper", {
            type = "data source",
            text = "",
            label = "",
            icon = "Interface\\Icons\\Classicon_mage"
        })

        -- Only onetime init.
        InitTextFrame()
        
        --Block the crappy portals in channels.
        ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", NoWhisperWindow)
        ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", NoWhisperWindow)
        ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", NoWhisperWindow)
        ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", NoWhisperWindow)
    
        
        self:RegisterChatCommand("mpw", "ConsoleCommand")
        
	end
    
end
